/* tslint:disable */
/* eslint-disable */
/**
 * e-commerce-service
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.1.74
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../base';
/**
 * InventoriesApi - axios parameter creator
 * @export
 */
export const InventoriesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} productId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        productInventoryControllerGetProductInventoryDetail: async (productId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'productId' is not null or undefined
            assertParamExists('productInventoryControllerGetProductInventoryDetail', 'productId', productId)
            const localVarPath = `/inventories/products/{productId}`
                .replace(`{${"productId"}}`, encodeURIComponent(String(productId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} pageIndex 
         * @param {number} pageSize 
         * @param {Array<string>} [productIds] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        productInventoryControllerGetProductInventoryList: async (pageIndex: number, pageSize: number, productIds?: Array<string>, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'pageIndex' is not null or undefined
            assertParamExists('productInventoryControllerGetProductInventoryList', 'pageIndex', pageIndex)
            // verify required parameter 'pageSize' is not null or undefined
            assertParamExists('productInventoryControllerGetProductInventoryList', 'pageSize', pageSize)
            const localVarPath = `/inventories/products`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)

            if (productIds) {
                localVarQueryParameter['productIds'] = productIds;
            }

            if (pageIndex !== undefined) {
                localVarQueryParameter['pageIndex'] = pageIndex;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['pageSize'] = pageSize;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * InventoriesApi - functional programming interface
 * @export
 */
export const InventoriesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = InventoriesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string} productId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async productInventoryControllerGetProductInventoryDetail(productId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.productInventoryControllerGetProductInventoryDetail(productId, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['InventoriesApi.productInventoryControllerGetProductInventoryDetail']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 
         * @param {number} pageIndex 
         * @param {number} pageSize 
         * @param {Array<string>} [productIds] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async productInventoryControllerGetProductInventoryList(pageIndex: number, pageSize: number, productIds?: Array<string>, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.productInventoryControllerGetProductInventoryList(pageIndex, pageSize, productIds, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['InventoriesApi.productInventoryControllerGetProductInventoryList']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
    }
};

/**
 * InventoriesApi - factory interface
 * @export
 */
export const InventoriesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = InventoriesApiFp(configuration)
    return {
        /**
         * 
         * @param {string} productId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        productInventoryControllerGetProductInventoryDetail(productId: string, options?: any): AxiosPromise<void> {
            return localVarFp.productInventoryControllerGetProductInventoryDetail(productId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {number} pageIndex 
         * @param {number} pageSize 
         * @param {Array<string>} [productIds] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        productInventoryControllerGetProductInventoryList(pageIndex: number, pageSize: number, productIds?: Array<string>, options?: any): AxiosPromise<void> {
            return localVarFp.productInventoryControllerGetProductInventoryList(pageIndex, pageSize, productIds, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * InventoriesApi - object-oriented interface
 * @export
 * @class InventoriesApi
 * @extends {BaseAPI}
 */
export class InventoriesApi extends BaseAPI {
    /**
     * 
     * @param {string} productId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof InventoriesApi
     */
    public productInventoryControllerGetProductInventoryDetail(productId: string, options?: RawAxiosRequestConfig) {
        return InventoriesApiFp(this.configuration).productInventoryControllerGetProductInventoryDetail(productId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {number} pageIndex 
     * @param {number} pageSize 
     * @param {Array<string>} [productIds] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof InventoriesApi
     */
    public productInventoryControllerGetProductInventoryList(pageIndex: number, pageSize: number, productIds?: Array<string>, options?: RawAxiosRequestConfig) {
        return InventoriesApiFp(this.configuration).productInventoryControllerGetProductInventoryList(pageIndex, pageSize, productIds, options).then((request) => request(this.axios, this.basePath));
    }
}

